﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Threading;
using System.Runtime.InteropServices;
using System.IO;

namespace ModbusRTU
{
    public partial class Form1 : Form
    {
        #region[定義變量]
        Thread Thread_Modbus = null;
        System.Timers.Timer Timer_Modbus = new System.Timers.Timer();
        public bool runStatus = false;
        public bool setStatus = false;
        public int meanFlag = 0;
        public string receiveReport = string.Empty;
        public string Temperature = string.Empty;
        public string v_temp = string.Empty;
        public string c_temp = string.Empty;
        public string[] RecordData = new string[40];
        public string[] SetMode = new string[20];
        #endregion

        #region[Form1]
        public Form1()
        {
            InitializeComponent();
            InitComSetting();
            InitModeSetting();
            TimerSet();
        }
        #endregion

        #region[InitCom]
        public void InitComSetting()
        {
            //init port
            string[] port = new string[] { "COM1", "COM2", "COM3", "COM4", "COM5", "COM6", "COM7", "COM8", "COM9" };
            this.comboBox_port.Items.AddRange(port);
            this.comboBox_port.SelectedIndex = 0;
            //init baudr     
            string[] baudr = new string[] { "300", "600", "1200", "2400", "4800", "9600", "19200", "38400", "43000", "56000", "115200" };
            this.comboBox_baudr.Items.AddRange(baudr);
            this.comboBox_baudr.SelectedIndex = 5;
            //init prity
            string[] prity = new string[] { "None", "Odd", "Even"};
            this.comboBox_parity.Items.AddRange(prity);
            this.comboBox_parity.SelectedIndex = 0;
            //init datab
            string[] datab = new string[] { "8", "7", "6" };
            this.comboBox_datab.Items.AddRange(datab);
            this.comboBox_datab.SelectedIndex = 0;
            //init stopb
            string[] stopb = new string[] { "One", "Two"};
            this.comboBox_stopb.Items.AddRange(stopb);
            this.comboBox_stopb.SelectedIndex = 0;            
        }
        #endregion

        #region[InitMode]
        public void InitModeSetting()
        {
            string[] mode = new string[] { "CV", "CC", "CW", "CR" };
            this.comboBox_tmode.Items.AddRange(mode);
            this.comboBox_tmode.SelectedIndex = 0;
        }
        #endregion

        #region[InitValue]
        private void comboBox_tmode_SelectedIndexChanged(object sender, EventArgs e)
        {
            string strmode = this.comboBox_tmode.Text.Trim();
            this.comboBox_svalue.Items.Clear();
            this.comboBox_svalue.Text = "";
            switch (strmode)
            {
                case "CV":
                    this.comboBox_svalue.Items.Add("5.00");
                    this.comboBox_svalue.Items.Add("5.99");
                    this.comboBox_svalue.Items.Add("12.00");
                    break;
                case "CC":
                    this.comboBox_svalue.Items.Add("1.000");
                    this.comboBox_svalue.Items.Add("1.500");
                    this.comboBox_svalue.Items.Add("2.000");
                    break;
                case "CW":
                    this.comboBox_svalue.Items.Add("10.00");
                    this.comboBox_svalue.Items.Add("20.00");
                    this.comboBox_svalue.Items.Add("30.00");
                    break;
                case "CR":
                    this.comboBox_svalue.Items.Add("10.0");
                    this.comboBox_svalue.Items.Add("50.0");
                    this.comboBox_svalue.Items.Add("100.0");
                    break;
                default:
                    break;
            }
        }
        #endregion

        #region[SetText]
        private delegate void SetTextCallback(string text);
        public void SetText(string text)
        {
            if (this.textBox_UI.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(SetText);
                this.Invoke(d, new object[] { text });
            }
            else
            {
                //this.textBox_UI.Text = this.textBox_UI.Text + "\r\n" + text + "\r\n";
                this.textBox_UI.Text = this.textBox_UI.Text + "\r\n" + DateTime.Now.ToString("HH:mm:ss:fff") + "->" + text + "\r\n";
            }
        }
        #endregion        
        
        #region[Com_RS485_DataReceived]
        private void Com_RS485_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            SetText("Com receive message...");
            Thread.Sleep(50);
            Application.DoEvents();   
         
            try
            {
                int len = Com_RS485.BytesToRead;                
                if (len > 0)
                {
                    byte[] readbuf = new byte[len];
                    Com_RS485.Read(readbuf, 0, len);
                    for (int i = 0; i < len; i++)
                    {
                        receiveReport += readbuf[i].ToString("X2") + " ";
                    }
                    receiveReport = receiveReport.Trim();
                    SetText("receiveReport: " + receiveReport);
                }              
            }
            catch (Exception ex)
            {
                SetText("ReadCom:" + ex.Message);
            }
        }
        #endregion

        #region[button_com_Click]
        private void button_com_Click(object sender, EventArgs e)
        {
            if (this.button_com.Text == "CLOSE")
            {
                if (this.Com_RS485.IsOpen)
                {
                    this.Com_RS485.Close();
                }

                this.button_com.Text = "OPEN";
                this.comboBox_port.Enabled = true;
                this.comboBox_baudr.Enabled = true;
                this.comboBox_parity.Enabled = true;
                this.comboBox_datab.Enabled = true;
                this.comboBox_stopb.Enabled = true;
                this.button_com.ForeColor = Color.Gray;
                this.ovalShape_com.FillColor = Color.Gray;
            }
            else 
            {
                if (this.Com_RS485.IsOpen)
                {
                    this.Com_RS485.Close();
                }

                this.Com_RS485.PortName = this.comboBox_port.Text;
                this.Com_RS485.BaudRate = Convert.ToInt32(this.comboBox_baudr.Text.ToString());
                this.Com_RS485.Parity = Parity.None; //無奇偶校驗位
                this.Com_RS485.DataBits = Convert.ToInt32(this.comboBox_datab.Text.ToString());
                this.Com_RS485.StopBits = StopBits.One; //1位停止位
                this.Com_RS485.WriteTimeout = 1000; //寫超時
                this.Com_RS485.ReadTimeout = 1000; //讀超時
                this.Com_RS485.ReceivedBytesThreshold = 1; //接收緩衝區當中如果有一個字節的話，就觸發接收函數               
                this.Com_RS485.DataReceived += new SerialDataReceivedEventHandler(this.Com_RS485_DataReceived); //添加事件註冊

                try
                {
                    this.Com_RS485.Open();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "OpenCOM提示信息", MessageBoxButtons.OK, MessageBoxIcon.Error);                   
                }

                if (this.Com_RS485.IsOpen)
                {
                    this.button_com.Text = "CLOSE";
                    this.comboBox_port.Enabled = false;
                    this.comboBox_baudr.Enabled = false;
                    this.comboBox_parity.Enabled = false;
                    this.comboBox_datab.Enabled = false;
                    this.comboBox_stopb.Enabled = false;
                    this.button_com.ForeColor = Color.Green;
                    this.ovalShape_com.FillColor = Color.Lime;
                }
            }
        }
        #endregion

        #region[button_set_Click]
        private void button_set_Click(object sender, EventArgs e)
        {           
            string tmode = this.comboBox_tmode.Text;
            string svalue = this.comboBox_svalue.Text;
            SetText("COMStatus: " + this.Com_RS485.IsOpen);
            if (string.IsNullOrEmpty(tmode))
            {
                MessageBox.Show("TestMode is NULL", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (string.IsNullOrEmpty(svalue))
            {
                MessageBox.Show("SetValue is NULL", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (this.Com_RS485.IsOpen == false)
            {
                if (this.button_com.Text == "CLOSE")
                {
                    try
                    {
                        Com_RS485.Open();
                        SetText("set button reopen Com Pass");
                    }
                    catch (Exception ex)
                    {
                        SetText("set COM Fail: " + ex.Message);
                    }
                }
                if (!Com_RS485.IsOpen)
                {
                    MessageBox.Show("COM is not connected", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }                
            }
            setStatus = false;
            this.textBox_UI.Clear(); //清屏

            string get_mode = this.comboBox_tmode.Text.Trim();
            //第一步：設置模式
            SendDataToCom(get_mode, "Mode");
            //第一步：設置參數
            SendDataToCom(get_mode, "Value");
            setStatus = true;
            SetText("setStatus: " + setStatus);               
        }
        #endregion

        #region[button_clear_Click]
        private void button_clear_Click(object sender, EventArgs e)
        {
            if (this.checkBox_M1.Enabled == false)
            {
                this.checkBox_M1.Enabled = true;
                this.checkBox_M1.Checked = false;
                this.textBox_SM1.Text = "";
                this.textBox_RM1.Text = "";
            }
            if (this.checkBox_M2.Enabled == false)
            {
                this.checkBox_M2.Enabled = true;
                this.checkBox_M2.Checked = false;
                this.textBox_SM2.Text = "";
                this.textBox_RM2.Text = "";
            }
            if (this.checkBox_M3.Enabled == false)
            {
                this.checkBox_M3.Enabled = true;
                this.checkBox_M3.Checked = false;
                this.textBox_SM3.Text = "";
                this.textBox_RM3.Text = "";
            }
            if (this.checkBox_M4.Enabled == false)
            {
                this.checkBox_M4.Enabled = true;
                this.checkBox_M4.Checked = false;
                this.textBox_SM4.Text = "";
                this.textBox_RM4.Text = "";
            }
            if (this.checkBox_M5.Enabled == false)
            {
                this.checkBox_M5.Enabled = true;
                this.checkBox_M5.Checked = false;
                this.textBox_SM5.Text = "";
                this.textBox_RM5.Text = "";
            }
            if (this.checkBox_M6.Enabled == false)
            {
                this.checkBox_M6.Enabled = true;
                this.checkBox_M6.Checked = false;
                this.textBox_SM6.Text = "";
                this.textBox_RM6.Text = ""; ;
            }
            if (this.checkBox_M7.Enabled == false)
            {
                this.checkBox_M7.Enabled = true;
                this.checkBox_M7.Checked = false;
                this.textBox_SM7.Text = "";
                this.textBox_RM7.Text = "";
            }
            if (this.checkBox_M8.Enabled == false)
            {
                this.checkBox_M8.Enabled = true;
                this.checkBox_M8.Checked = false;
                this.textBox_SM8.Text = "";
                this.textBox_RM8.Text = "";
            }
            if (this.checkBox_M9.Enabled == false)
            {
                this.checkBox_M9.Enabled = true;
                this.checkBox_M9.Checked = false;
                this.textBox_SM9.Text = "";
                this.textBox_RM9.Text = "";
            }
            if (this.checkBox_M10.Enabled == false)
            {
                this.checkBox_M10.Enabled = true;
                this.checkBox_M10.Checked = false;
                this.textBox_SM10.Text = "";
                this.textBox_RM10.Text = "";
            }
            if (this.checkBox_M11.Enabled == false)
            {
                this.checkBox_M11.Enabled = true;
                this.checkBox_M11.Checked = false;
                this.textBox_SM11.Text = "";
                this.textBox_RM11.Text = "";
            }
            if (this.checkBox_M12.Enabled == false)
            {
                this.checkBox_M12.Enabled = true;
                this.checkBox_M12.Checked = false;
                this.textBox_SM12.Text = "";
                this.textBox_RM12.Text = "";
            }
            if (this.checkBox_M13.Enabled == false)
            {
                this.checkBox_M13.Enabled = true;
                this.checkBox_M13.Checked = false;
                this.textBox_SM13.Text = "";
                this.textBox_RM13.Text = "";
            }
            if (this.checkBox_M14.Enabled == false)
            {
                this.checkBox_M14.Enabled = true;
                this.checkBox_M14.Checked = false;
                this.textBox_SM14.Text = "";
                this.textBox_RM14.Text = "";
            }
            if (this.checkBox_M15.Enabled == false)
            {
                this.checkBox_M15.Enabled = true;
                this.checkBox_M15.Checked = false;
                this.textBox_SM15.Text = "";
                this.textBox_RM15.Text = "";    
            }
            if (this.checkBox_M16.Enabled == false)
            {
                this.checkBox_M16.Enabled = true;
                this.checkBox_M16.Checked = false;
                this.textBox_SM16.Text = "";
                this.textBox_RM16.Text = "";
            }
            if (this.checkBox_M17.Enabled == false)
            {
                this.checkBox_M17.Enabled = true;
                this.checkBox_M17.Checked = false;
                this.textBox_SM17.Text = "";
                this.textBox_RM17.Text = "";
            }
            if (this.checkBox_M18.Enabled == false)
            {
                this.checkBox_M18.Enabled = true;
                this.checkBox_M18.Checked = false;
                this.textBox_SM18.Text = "";
                this.textBox_RM18.Text = "";
            }
            if (this.checkBox_M19.Enabled == false)
            {
                this.checkBox_M19.Enabled = true;
                this.checkBox_M19.Checked = false;
                this.textBox_SM19.Text = "";
                this.textBox_RM19.Text = "";
            }
            if (this.checkBox_M20.Enabled == false)
            {
                this.checkBox_M20.Enabled = true;
                this.checkBox_M20.Checked = false;
                this.textBox_SM20.Text = "";
                this.textBox_RM20.Text = "";
            }
            Array.Clear(SetMode,0,20);
        }
        #endregion

        #region[button_start_Click]
        private void button_start_Click(object sender, EventArgs e)
        {
            if (!Com_RS485.IsOpen) //COM被關閉
            {
                if (this.button_com.Text == "CLOSE") //已經開啟COM，但是中途被拔掉串口重新插入
                {
                    try
                    {
                        Com_RS485.Open();
                        SetText("start button reopen Com Pass");
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show("COM Fail: " + ex.Message);
                    }
                }
            }
            if (Com_RS485.IsOpen)
            {
                if (setStatus == true) //參數設置完成
                {
                    if (MessageBox.Show("請確認是否設置完成?", "Message", MessageBoxButtons.OKCancel) == DialogResult.OK)
                    {
                        this.textBox_UI.Clear();

                        //第三步：設置開關     
                        SendDataToCom("", "Key");

                        this.button_com.Enabled = false;
                        this.button_clear.Visible = false; //控件不可見
                        this.button_set.Visible = false;
                        this.button_start.Enabled = false; //置START button為不可操控             
                        this.Timer_Modbus.Enabled = true;  //開啟Timer_Modbus
                        this.ovalShape_timer.FillColor = Color.Lime;
                        runStatus = true;
                    }
                    else
                    {
                        SetText("continue setting...");
                    }
                }
                else
                {
                    SetText("pls waiting parameter setting finish...");
                }
            }
            else
            {
                MessageBox.Show("請檢查COM,重新打開COM", "Warining", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        #endregion

        #region[button_stop_Click]
        private void button_stop_Click(object sender, EventArgs e)
        {
            this.ovalShape_timer.FillColor = Color.Gray;
            if (this.button_start.Enabled == false)
            {
                this.button_start.Enabled = true;
            }
            if (this.button_clear.Visible == false)
            {
                this.button_clear.Visible = true;                
            }
            if(this.button_set.Visible == false)
            {
                this.button_set.Visible = true;
            }
            if (this.button_com.Enabled == false)
            {
                this.button_com.Enabled = true;
            }
            if (runStatus == true)
            {
                runStatus = false;
                if (Timer_Modbus.Enabled == true)
                {
                    Timer_Modbus.Enabled = false;
                }
                if (Thread_Modbus != null)
                {
                    Thread_Modbus.Abort();
                }
            }
        }
        #endregion

        #region[ShowTextBox]
        public void ShowTextBox(int a, string result,string type)
        {
            switch (a)
            {
                case 0:
                    if (type == "SET")
                    {
                        this.checkBox_M1.Enabled = false;                        
                        this.textBox_SM1.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM1.ForeColor = Color.Green;
                        }
                        else //FAIL
                        {                           
                            this.textBox_SM1.ForeColor = Color.Red;
                        }
                    }
                    else //READ
                    {
                        if (SetMode[0] == "CV")
                        {
                            this.textBox_RM1.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM1.Text = c_temp;
                        }                      
                    }
                    break;
                case 1:
                    if (type == "SET")
                    {
                        this.checkBox_M2.Enabled = false;
                        this.textBox_SM2.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM2.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM2.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[1] == "CV")
                        {
                            this.textBox_RM2.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM2.Text = c_temp;
                        }              
                    }
                    break;
                case 2:
                    if (type == "SET")
                    {
                        this.checkBox_M3.Enabled = false;
                        this.textBox_SM3.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM3.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM3.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[2] == "CV")
                        {
                            this.textBox_RM3.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM3.Text = c_temp;
                        }              
                    }
                    break;
                case 3:
                    if (type == "SET")
                    {
                        this.checkBox_M4.Enabled = false;
                        this.textBox_SM4.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM4.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM4.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[3] == "CV")
                        {
                            this.textBox_RM4.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM4.Text = c_temp;
                        }           
                    }
                    break;
                case 4:
                    if (type == "SET")
                    {
                        this.checkBox_M5.Enabled = false;
                        this.textBox_SM5.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM5.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM5.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[4] == "CV")
                        {
                            this.textBox_RM5.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM5.Text = c_temp;
                        } 
                    }
                    break;
                case 5:
                    if (type == "SET")
                    {
                        this.checkBox_M6.Enabled = false;
                        this.textBox_SM6.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM6.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM6.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[5] == "CV")
                        {
                            this.textBox_RM6.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM6.Text = c_temp;
                        } 
                    }
                    break;
                case 6:
                    if (type == "SET")
                    {
                        this.checkBox_M7.Enabled = false;
                        this.textBox_SM7.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM7.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM7.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[6] == "CV")
                        {
                            this.textBox_RM7.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM7.Text = c_temp;
                        } 
                    }
                    break;
                case 7:
                    if (type == "SET")
                    {
                        this.checkBox_M8.Enabled = false;
                        this.textBox_SM8.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM8.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM8.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[7] == "CV")
                        {
                            this.textBox_RM8.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM8.Text = c_temp;
                        } 
                    }
                    break;
                case 8:
                    if (type == "SET")
                    {
                        this.checkBox_M9.Enabled = false;
                        this.textBox_SM9.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM9.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM9.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[8] == "CV")
                        {
                            this.textBox_RM9.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM9.Text = c_temp;
                        } 
                    }
                    break;
                case 9:
                    if (type == "SET")
                    {
                        this.checkBox_M10.Enabled = false;
                        this.textBox_SM10.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM10.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM10.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[9] == "CV")
                        {
                            this.textBox_RM10.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM10.Text = c_temp;
                        } 
                    }
                    break;
                case 10:
                    if (type == "SET")
                    {
                        this.checkBox_M11.Enabled = false;
                        this.textBox_SM11.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM11.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM11.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[10] == "CV")
                        {
                            this.textBox_RM11.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM11.Text = c_temp;
                        } 
                    }
                    break;
                case 11:
                    if (type == "SET")
                    {
                        this.checkBox_M12.Enabled = false;
                        this.textBox_SM12.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM12.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM12.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[11] == "CV")
                        {
                            this.textBox_RM12.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM12.Text = c_temp;
                        } 
                    }
                    break;
                case 12:
                    if (type == "SET")
                    {
                        this.checkBox_M13.Enabled = false;
                        this.textBox_SM13.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM13.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM13.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[12] == "CV")
                        {
                            this.textBox_RM13.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM13.Text = c_temp;
                        } 
                    }
                    break;
                case 13:
                    if (type == "SET")
                    {
                        this.checkBox_M14.Enabled = false;
                        this.textBox_SM14.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM14.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM14.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[13] == "CV")
                        {
                            this.textBox_RM14.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM14.Text = c_temp;
                        } 
                    }
                    break;
                case 14:
                    if (type == "SET")
                    {
                        this.checkBox_M15.Enabled = false;
                        this.textBox_SM15.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM15.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM15.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[14] == "CV")
                        {
                            this.textBox_RM15.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM15.Text = c_temp;
                        } 
                    }
                    break;
                case 15:
                    if (type == "SET")
                    {
                        this.checkBox_M16.Enabled = false;
                        this.textBox_SM16.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM16.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM16.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[15] == "CV")
                        {
                            this.textBox_RM16.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM16.Text = c_temp;
                        }
                    }
                    break;
                case 16:
                    if (type == "SET")
                    {
                        this.checkBox_M17.Enabled = false;
                        this.textBox_SM17.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM17.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM17.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[16] == "CV")
                        {
                            this.textBox_RM17.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM17.Text = c_temp;
                        }
                    }
                    break;
                case 17:
                    if (type == "SET")
                    {
                        this.checkBox_M18.Enabled = false;
                        this.textBox_SM18.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM18.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM18.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[17] == "CV")
                        {
                            this.textBox_RM18.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM18.Text = c_temp;
                        }
                    }
                    break;
                case 18:
                    if (type == "SET")
                    {
                        this.checkBox_M19.Enabled = false;
                        this.textBox_SM19.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM19.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM19.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[18] == "CV")
                        {
                            this.textBox_RM19.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM19.Text = c_temp;
                        }
                    }
                    break;
                case 19:
                    if (type == "SET")
                    {
                        this.checkBox_M20.Enabled = false;
                        this.textBox_SM20.Text = this.comboBox_svalue.Text;
                        if (result == "PASS")
                        {
                            this.textBox_SM20.ForeColor = Color.Green;
                        }
                        else
                        {
                            this.textBox_SM20.ForeColor = Color.Red;
                        }
                    }
                    else
                    {
                        if (SetMode[19] == "CV")
                        {
                            this.textBox_RM20.Text = v_temp;
                        }
                        else
                        {
                            this.textBox_RM20.Text = c_temp;
                        }
                    }
                    break;                
                default:
                    break;
            }
        }
        #endregion

        #region[GetSlaveAddress]
        public string[] GetSlaveAddress(string smode) 
        {
            string[] sl_add = new string[20];

            if (this.checkBox_M1.Enabled == true && this.checkBox_M1.Checked)
            {
                sl_add[0] = "01";
                SetMode[0] = smode;
            }
            else
            {
                sl_add[0] = "00";
                SetMode[0] = "0";
            }
            if (this.checkBox_M2.Enabled == true && this.checkBox_M2.Checked)
            {               
                sl_add[1] = "02";
                SetMode[1] = smode;
            }
            else
            {
                sl_add[1] = "00";
                SetMode[1] = "0";
            }
            if (this.checkBox_M3.Enabled == true && this.checkBox_M3.Checked)
            {               
                sl_add[2] = "03";
                SetMode[2] = smode;
            }
            else
            {
                sl_add[2] = "00";
                SetMode[2] = "0";
            }
            if (this.checkBox_M4.Enabled == true && this.checkBox_M4.Checked)
            {               
                sl_add[3] = "04";
                SetMode[3] = smode;
            }
            else
            {
                sl_add[3] = "00";
                SetMode[3] = "0";
            }
            if (this.checkBox_M5.Enabled == true && this.checkBox_M5.Checked)
            {                
                sl_add[4] = "05";
                SetMode[4] = smode;
            }
            else
            {
                sl_add[4] = "00";
                SetMode[4] = "0";
            }
            if (this.checkBox_M6.Enabled == true && this.checkBox_M6.Checked)
            {                
                sl_add[5] = "06";
                SetMode[5] = smode;
            }
            else
            {
                sl_add[5] = "00";
                SetMode[5] = "0";
            }
            if (this.checkBox_M7.Enabled == true && this.checkBox_M7.Checked)
            {               
                sl_add[6] = "07";
                SetMode[6] = smode;
            }
            else
            {
                sl_add[6] = "00";
                SetMode[6] = "0";
            }
            if (this.checkBox_M8.Enabled == true && this.checkBox_M8.Checked)
            {                
                sl_add[7] = "08";
                SetMode[7] = smode;
            }
            else
            {
                sl_add[7] = "00";
                SetMode[7] = "0";
            }
            if (this.checkBox_M9.Enabled == true && this.checkBox_M9.Checked)
            {                
                sl_add[8] = "09";
                SetMode[8] = smode;
            }
            else
            {
                sl_add[8] = "00";
                SetMode[8] = "0";
            }
            if (this.checkBox_M10.Enabled == true && this.checkBox_M10.Checked)
            {                
                sl_add[9] = "0A";
                SetMode[9] = smode;
            }
            else
            {
                sl_add[9] = "00";
                SetMode[9] = "0";
            }
            if (this.checkBox_M11.Enabled == true && this.checkBox_M11.Checked)
            {                
                sl_add[10] = "0B";
                SetMode[10] = smode;
            }
            else
            {
                sl_add[10] = "00";
                SetMode[10] = "0";
            }
            if (this.checkBox_M12.Enabled == true && this.checkBox_M12.Checked)
            {                
                sl_add[11] = "0C";
                SetMode[11] = smode;
            }
            else
            {
                sl_add[11] = "00";
                SetMode[11] = "0";
            }
            if (this.checkBox_M13.Enabled == true && this.checkBox_M13.Checked)
            {                
                sl_add[12] = "0D";
                SetMode[12] = smode;
            }
            else
            {
                sl_add[12] = "00";
                SetMode[12] = "0";
            }
            if (this.checkBox_M14.Enabled == true && this.checkBox_M14.Checked)
            {                
                sl_add[13] = "0E";
                SetMode[13] = smode;
            }
            else
            {
                sl_add[13] = "00";
                SetMode[13] = "0";
            }
            if (this.checkBox_M15.Enabled == true && this.checkBox_M15.Checked)
            {                
                sl_add[14] = "0F";
                SetMode[14] = smode;
            }
            else
            {
                sl_add[14] = "00";
                SetMode[14] = "0";
            }
            if (this.checkBox_M16.Enabled == true && this.checkBox_M16.Checked)
            {                
                sl_add[15] = "10";
                SetMode[15] = smode;
            }
            else
            {
                sl_add[15] = "00";
                SetMode[15] = "0";
            }
            if (this.checkBox_M17.Enabled == true && this.checkBox_M17.Checked)
            {                
                sl_add[16] = "11";
                SetMode[16] = smode;
            }
            else
            {
                sl_add[16] = "00";
                SetMode[16] = "0";
            }
            if (this.checkBox_M18.Enabled == true && this.checkBox_M18.Checked)
            {               
                sl_add[17] = "12";
                SetMode[17] = smode;
            }
            else
            {
                sl_add[17] = "00";
                SetMode[17] = "0";
            }
            if (this.checkBox_M19.Enabled == true && this.checkBox_M19.Checked)
            {                
                sl_add[18] = "13";
                SetMode[18] = smode;
            }
            else
            {
                sl_add[18] = "00";
                SetMode[18] = "0";
            }
            if (this.checkBox_M20.Enabled == true && this.checkBox_M20.Checked)
            {                
                sl_add[19] = "14";
                SetMode[19] = smode;
            }
            else
            {
                sl_add[19] = "00";
                SetMode[19] = "0";
            }
            return sl_add;
        }
        #endregion

        #region[GetSlaveAddress_Read]
        public string[] GetSlaveAddress_Read()
        {
            string[] sl_add = new string[20];

            if (this.checkBox_M1.Enabled == false && this.checkBox_M1.Checked && this.textBox_SM1.ForeColor == Color.Green)
            {
                sl_add[0] = "01";
            }
            else
            {
                sl_add[0] = "00";
            }
            if (this.checkBox_M2.Enabled == false && this.checkBox_M2.Checked && this.textBox_SM2.ForeColor == Color.Green)
            {
                sl_add[1] = "02";
            }
            else
            {
                sl_add[1] = "00";
            }
            if (this.checkBox_M3.Enabled == false && this.checkBox_M3.Checked && this.textBox_SM3.ForeColor == Color.Green)
            {
                sl_add[2] = "03";
            }
            else
            {
                sl_add[2] = "00";
            }
            if (this.checkBox_M4.Enabled == false && this.checkBox_M4.Checked && this.textBox_SM4.ForeColor == Color.Green)
            {
                sl_add[3] = "04";
            }
            else
            {
                sl_add[3] = "00";
            }
            if (this.checkBox_M5.Enabled == false && this.checkBox_M5.Checked && this.textBox_SM5.ForeColor == Color.Green)
            {
                sl_add[4] = "05";
            }
            else
            {
                sl_add[4] = "00";
            }
            if (this.checkBox_M6.Enabled == false && this.checkBox_M6.Checked && this.textBox_SM6.ForeColor == Color.Green)
            {
                sl_add[5] = "06";
            }
            else
            {
                sl_add[5] = "00";
            }
            if (this.checkBox_M7.Enabled == false && this.checkBox_M7.Checked && this.textBox_SM7.ForeColor == Color.Green)
            {
                sl_add[6] = "07";
            }
            else
            {
                sl_add[6] = "00";
            }
            if (this.checkBox_M8.Enabled == false && this.checkBox_M8.Checked && this.textBox_SM8.ForeColor == Color.Green)
            {
                sl_add[7] = "08";
            }
            else
            {
                sl_add[7] = "00";
            }
            if (this.checkBox_M9.Enabled == false && this.checkBox_M9.Checked && this.textBox_SM9.ForeColor == Color.Green)
            {
                sl_add[8] = "09";
            }
            else
            {
                sl_add[8] = "00";
            }
            if (this.checkBox_M10.Enabled == false && this.checkBox_M10.Checked && this.textBox_SM10.ForeColor == Color.Green)
            {
                sl_add[9] = "0A";
            }
            else
            {
                sl_add[9] = "00";
            }
            if (this.checkBox_M11.Enabled == false && this.checkBox_M11.Checked && this.textBox_SM11.ForeColor == Color.Green)
            {
                sl_add[10] = "0B";
            }
            else
            {
                sl_add[10] = "00";
            }
            if (this.checkBox_M12.Enabled == false && this.checkBox_M12.Checked && this.textBox_SM12.ForeColor == Color.Green)
            {
                sl_add[11] = "0C";
            }
            else
            {
                sl_add[11] = "00";
            }
            if (this.checkBox_M13.Enabled == false && this.checkBox_M13.Checked && this.textBox_SM13.ForeColor == Color.Green)
            {
                sl_add[12] = "0D";
            }
            else
            {
                sl_add[12] = "00";
            }
            if (this.checkBox_M14.Enabled == false && this.checkBox_M14.Checked && this.textBox_SM14.ForeColor == Color.Green)
            {
                sl_add[13] = "0E";
            }
            else
            {
                sl_add[13] = "00";
            }
            if (this.checkBox_M15.Enabled == false && this.checkBox_M15.Checked && this.textBox_SM15.ForeColor == Color.Green)
            {
                sl_add[14] = "0F";
            }
            else
            {
                sl_add[14] = "00";
            }
            if (this.checkBox_M16.Enabled == false && this.checkBox_M16.Checked && this.textBox_SM16.ForeColor == Color.Green)
            {
                sl_add[15] = "10";
            }
            else
            {
                sl_add[15] = "00";
            }
            if (this.checkBox_M17.Enabled == false && this.checkBox_M17.Checked && this.textBox_SM17.ForeColor == Color.Green)
            {
                sl_add[16] = "11";
            }
            else
            {
                sl_add[16] = "00";
            }
            if (this.checkBox_M18.Enabled == false && this.checkBox_M18.Checked && this.textBox_SM18.ForeColor == Color.Green)
            {
                sl_add[17] = "12";
            }
            else
            {
                sl_add[17] = "00";
            }
            if (this.checkBox_M19.Enabled == false && this.checkBox_M19.Checked && this.textBox_SM19.ForeColor == Color.Green)
            {
                sl_add[18] = "13";
            }
            else
            {
                sl_add[18] = "00";
            }
            if (this.checkBox_M20.Enabled == false && this.checkBox_M20.Checked && this.textBox_SM20.ForeColor == Color.Green)
            {
                sl_add[19] = "14";
            }
            else
            {
                sl_add[19] = "00";
            }
            return sl_add;
        }
        #endregion

        #region[SetTestMode]
        public string SetTestMode(string selectmode)
        {
            string stm = "06 00 01 00";          
            switch(selectmode)
            {
                case "CV":
                    stm = stm + " " + "00";
                    break;
                case "CC":
                    stm = stm + " " + "01";
                    break;
                case "CW":
                    stm = stm + " " + "02";
                    break;
                case "CR":
                    stm = stm + " " + "03";
                    break;
                default:                    
                    break;
            }
            return stm;
        }
        #endregion

        #region[SetTestValue]
        public string SetTestValue(string selectmode)
        {            
            string[] senddata = new string[5];
            int w_value = 0;
            int x_index = 0;
            string sdt = string.Empty;
            senddata[0] = "06"; //寫單個保持寄存器
            senddata[1] = "00";
            switch (selectmode)
            {
                case "CV":
                    senddata[2] = "03";
                    x_index = 100; //（两位小数）恒压测试                   
                    break;
                case "CC":
                    senddata[2] = "04";
                    x_index = 1000; //（三位小数）恒流测试                  
                    break;
                case "CW":
                    senddata[2] = "05";
                    x_index = 100; //（两位小数）恒功率测                 
                    break;
                case "CR":
                    senddata[2] = "06";
                    x_index = 10; //（一位小数）恒阻测试
                    break;
                default:
                    break;
            }
            w_value = (int)(Convert.ToDouble(this.comboBox_svalue.Text.ToString()) * x_index);
            senddata[3] = w_value.ToString("X4").Substring(0, 2);
            senddata[4] = w_value.ToString("X4").Substring(2, 2);
            for (int i = 0; i < 5; i++)
            {
                if (i < 4)
                {
                    sdt += senddata[i] + " ";
                }
                else
                {
                    sdt += senddata[i];
                }
            }
            return sdt;
        }
        #endregion

        #region[SendDataToCom]
        public void SendDataToCom(string selmode, string mean)
        {
            string instr = string.Empty;
            
            switch(mean)
            {
                case "Mode":
                    instr = SetTestMode(selmode);
                    break;
                case "Value":
                    instr = SetTestValue(selmode);
                    break;
                case "Key":
                    instr = "06 00 02 00 01";
                    break;               
                default:
                    break;
            }              
            
            string[] res_sladd = new string[20];
            string sendReport = string.Empty;
            if (mean == "Key")
            {
                res_sladd = GetSlaveAddress_Read();
            }
            else
            {
                res_sladd = GetSlaveAddress(selmode);
            }
            try
            {
                for (int add = 0; add < 20; add++)
                {
                    if (res_sladd[add].Equals("00"))
                    {
                        continue;
                    }
                    SetText(mean + " instr: " + instr);
                    sendReport = res_sladd[add] + " " + instr;
                    string res_crc = GetCRC(sendReport);
                    sendReport = sendReport + " " + res_crc;
                    SetText(mean + " sendReport: " + sendReport);
                    if (!WriteCom(sendReport, 1)) //FAIL
                    {
                        SetText("Set " + mean + " M" + (add + 1) + " Fail");
                        if (mean == "Value")
                        {
                            ShowTextBox(add, "FAIL", "SET");                            
                        }
                        Thread.Sleep(100);
                        Application.DoEvents();
                    }
                    else //PASS
                    {
                        SetText("Set " + mean + " M" + (add + 1) + " Pass");
                        if (mean == "Value")
                        {
                            ShowTextBox(add, "PASS", "SET");                            
                        }
                        Thread.Sleep(100);
                        Application.DoEvents();
                    }
                }
            }
            catch (Exception ex)
            {
                SetText("SendCom: " + ex.Message);
            }
        }
        #endregion

        #region[ReadVoltage_Current]
        public void ReadVoltage_Current() //讀取電壓電流
        {
            string rvc = "04 00 06 00 02"; //讀 寄地高 寄地低 寄數高 寄數低   
            meanFlag = 0;

            try
            {
                string[] res_sladd = new string[20];
                string seReport = string.Empty;
                res_sladd = GetSlaveAddress_Read();
                for (int iadd = 0; iadd < 20; iadd++)
                {
                    v_temp = string.Empty;
                    c_temp = string.Empty;

                    if (res_sladd[iadd].Equals("00"))
                    {                       
                        continue;
                    }
                    SetText("Read instr: " + rvc);
                    seReport = res_sladd[iadd] + " " + rvc;
                    string res_crc = GetCRC(seReport);
                    seReport = seReport + " " + res_crc;
                    SetText("Read sendReport: " + seReport);
                    if (!WriteCom(seReport, 2)) //FAIL
                    {
                        SetText("Read M" + (iadd + 1) + " Fail");
                        ShowTextBox(iadd, "FAIL", "READ");
                        meanFlag = 1;
                        Thread.Sleep(100);
                        Application.DoEvents();                        
                    }
                    else //PASS
                    {
                        SetText("M" + (iadd + 1) + " voltage: " + v_temp);
                        SetText("M" + (iadd + 1) + " currnet: " + c_temp);
                        RecordData[iadd * 2] = v_temp;
                        RecordData[iadd * 2 + 1] = c_temp;
                        ShowTextBox(iadd, "PASS", "READ");                        
                        Thread.Sleep(100);
                        Application.DoEvents();
                    }
                }
            }
            catch (Exception ex)
            {
                SetText("RVC: "+ex.ToString());
            }
        }
        #endregion

        #region[GetCRC]
        public string GetCRC(string dataByte)
        {
            string crc = string.Empty;
            string[] sp = new string[50];
            sp = dataByte.Split(' '); //以空格分隔
            int len = sp.Length;
            byte[] idata = new byte[len];
            for (int m = 0; m < len; m++)
            {
                idata[m] = System.Convert.ToByte(sp[m], 16);
            }
            uint crc16 = CRC16_Modbus(idata, (uint)len);
            string strcrc = crc16.ToString("X4"); //3321 //將十進制以十六進制顯示，且是4位 //X代表十六進制 4代碼格式是4位 不夠左補0
            string crcLo = strcrc.Substring(0, 2); //低位 33
            string crcHi = strcrc.Substring(2, 2); //高位 21
            crc = crcHi + " " + crcLo;
            return crc;
        }
        #endregion

        #region[CRC16_Modbus]
        public uint CRC16_Modbus(byte[] modbusdata, uint Length) //Length為modbusdata的長度
        {
            uint i, j;
            uint CRC16 = 0xFFFF; //預置16位寄存器為0xFFFF
            for (i = 0; i < Length; i++)
            {
                CRC16 ^= modbusdata[i]; //CRC = BYTE xor CRC
                for (j = 0; j < 8; j++) //檢查字節每一個bit
                {
                    if ((CRC16 & 0x01) == 1) //如果CRC最後為1，則右移一位且與0xA001進行xor運算
                    {
                        CRC16 = (CRC16 >> 1) ^ 0xA001;
                    }
                    else                     //如果CRC最後一位為0，則只將CRC右移一位
                    {
                        CRC16 = CRC16 >> 1;
                    }
                }
            }
            return CRC16;
        }
        #endregion

        #region[WriteCom]
        public bool WriteCom(string wdata,int flag)
        {            
            string[] sp = new string[50];            
            receiveReport = string.Empty;           
            sp = wdata.Split(' ');
            int len = sp.Length;
            byte[] idata = new byte[len];           
            for (int m = 0; m < len; m++)
            {
                sp[m] = "0x" + sp[m];
                idata[m] = (byte)Convert.ToInt32(sp[m],16);
            }

            try
            {
                if (!Com_RS485.IsOpen)
                {
                    try
                    {
                        Com_RS485.Open();
                        SetText("Reopen Com Pass");
                    }
                    catch (Exception ex)
                    {
                        SetText("Reopen Com Fail: " + ex.Message);
                        return false;
                    }
                    if (Com_RS485.IsOpen)
                    {
                        Com_RS485.Write(idata, 0, idata.Length);
                    }
                    else
                    {
                        SetText("WriteCom is close");
                        return false;
                    }
                }
                else
                {
                    Com_RS485.Write(idata, 0, idata.Length);
                }                
            }
            catch (Exception ex)
            {
                SetText("WriteCom: " + ex.Message);
                return false;
            }

            int timeout = 20;
            for (int itime = 0; itime <= timeout; itime++) //1000ms
            {
                if (itime == timeout)
                {
                    SetText("Timeout No receive data");                   
                    return false;
                }
                
                if (!string.IsNullOrEmpty(receiveReport))
                {                    
                    break;
                }
                else
                {
                    Thread.Sleep(50);
                    Application.DoEvents();
                    continue;
                }
            }
            
            string[] recvsp = new string[50];
            recvsp = receiveReport.Split(' ');
            int recvlen = recvsp.Length;
            if (flag == 1) //Write
            {
                if (recvlen != 8)
                {
                    SetText("Receive Data length is not 8 byte");
                    return false;
                }

                if (!receiveReport.Trim().Equals(wdata.Trim()))
                {
                    SetText("Receive Data is ERROR");
                    return false;
                }
            }
            else //Read
            {
                if (recvlen != 9)
                {
                    SetText("Receive Data length is not 9 byte");
                    return false;
                }
                string recvtmp = recvsp[0] + " " + recvsp[1] + " " + recvsp[2] + " " + recvsp[3] + " " + recvsp[4] + " " + recvsp[5] + " " + recvsp[6];
                string recv_crc = GetCRC(recvtmp);
                if (!recv_crc.Equals(recvsp[7] + " " + recvsp[8]))
                {
                    SetText("Receive Data CRC is ERROR");
                    return false;
                }
                else
                {
                    string vtemp = recvsp[3] + recvsp[4];
                    string ctemp = recvsp[5] + recvsp[6];
                    v_temp = (int.Parse(vtemp, System.Globalization.NumberStyles.HexNumber) / 100.0).ToString(); //將十六進制數的字符串轉換成整型
                    c_temp = (int.Parse(ctemp, System.Globalization.NumberStyles.HexNumber) / 1000.0).ToString();
                }
            }
            return true;
        }
        #endregion

        #region[WriteLogToCSV]
        public void WriteLogToCSV()
        {
            string ym = DateTime.Now.ToString("yyyyMM");
            string wdate = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
            string dir = "D:\\RecordLog\\" + ym;
            string file = string.Format("{0}\\{1}.csv", dir, DateTime.Now.ToString("yyyyMMdd"));
            string RecordLog = String.Empty;
            RecordLog = wdate + "," + Temperature + ",";           
            for (int n = 0; n < 40; n++)
            {
                if (n == 40 - 1)
                {
                    RecordLog += RecordData[n];
                }
                else
                {
                    RecordLog += RecordData[n] + ",";
                }              
            }            
            SetText("RecordLog: " + RecordLog);
            if (meanFlag == 1)
            {
                SaveUILog();
            }            
            try
            {
                if (!File.Exists(file))
                {
                    string title = "DATE" + "," + "T" + "," + "V1" + "," + "C1" + "," + "V2" + "," + "C2" + "," + "V3" + "," + "C3" + "," + "V4" + "," + "C4" + "," + "V5" + "," + "C5" + "," + "V6" + "," + "C6" + "," + "V7" + "," + "C7" + "," + "V8" + "," + "C8" + "," +
                                   "V9" + "," + "C9" + "," + "V10" + "," + "C10" + "," + "V11" + "," + "C11" + "," + "V12" + "," + "C12" + "," + "V13" + "," + "C13" + "," + "V14" + "," + "C14" + "," + "V15" + "," + "C15" + "," + "V16" + "," + "C16" + "," + "V17" + "," + "C17" + "," +
                                   "V18" + "," + "C18" + "," + "V19" + "," + "C19" + "," + "V20" + "," + "C20";

                    if (!Directory.Exists(dir))
                    {
                        Directory.CreateDirectory(dir);
                    }

                    StreamWriter sw = new StreamWriter(file, true, Encoding.Default);
                    sw.Write(title + "\n");
                    sw.Write(RecordLog + "\n");
                    sw.Close();
                }
                else
                {
                    StreamWriter sw = new StreamWriter(file, true, Encoding.Default);
                    sw.Write(RecordLog + "\n");
                    sw.Close();
                }
            }
            catch (Exception)
            {
                MessageBox.Show("CSV is be opened", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

            //清空
            Array.Clear(RecordData, 0, RecordData.Length);
            Temperature = string.Empty;            
        }
        #endregion

        #region[SaveUILog]
        public void SaveUILog()
        {
            string ym = DateTime.Now.ToString("yyyyMM");
            string dirUI = "D:\\RecordUI\\" + ym +"\\";
            string path = dirUI + DateTime.Now.ToString("yyyy-MM-dd-HH-mm-ss") + ".txt";
            if (!Directory.Exists(dirUI))
            {
                Directory.CreateDirectory(dirUI);
            }
            FileStream file = new FileStream(path, FileMode.Create, FileAccess.ReadWrite, FileShare.ReadWrite);
            StreamWriter writer = new StreamWriter(file);
            writer.WriteLine(textBox_UI.Text);
            writer.Close();
            file.Close();
        }

        private void button_save_Click(object sender, EventArgs e)
        {
            SaveUILog();
            this.textBox_UI.Clear();
        }
        #endregion

        #region[Form1_Load_Closed]
        private void Form1_Load(object sender, EventArgs e)
        {
            Control.CheckForIllegalCrossThreadCalls = false; //false-不檢查跨線程的條用是否合法 //true-檢查(默認是true)
            this.textBox_bd.Text = System.IO.File.GetLastWriteTime(this.GetType().Assembly.Location).ToString(); //獲取編譯時間
            this.textBox_ver.Text = "MRTU_V1.0.7"; //定義程序版本            
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (runStatus == true)
            {
                runStatus = false;
                if (Timer_Modbus.Enabled == true)
                {
                    Timer_Modbus.Enabled = false;
                }
                if (Thread_Modbus != null)
                {
                    Thread_Modbus.Abort();
                }                  
            }
            Com_RS485.Close();
        }
        #endregion

        #region[Timer]
        public void TimerSet() //實例化Timer
        {
            Timer_Modbus.Interval = 1000 * 30; //30ms
            Timer_Modbus.Elapsed += new System.Timers.ElapsedEventHandler(Modbus_ThreadMethod_Elapse);
            Timer_Modbus.AutoReset = true;
            Timer_Modbus.Enabled = false;
        }
        void Modbus_ThreadMethod_Elapse(object sender, EventArgs e)
        {            
            Thread_Modbus = new Thread(new ThreadStart(Modbus_ThreadMethod));
            Thread_Modbus.Start();
        }
        public void Modbus_ThreadMethod() 
        {
            this.textBox_UI.Clear();            
            ReadVoltage_Current();            
            WriteLogToCSV();           
        }        
        #endregion

        #region[鼠標左鍵雙擊清屏]
        private void textBox_UI_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            this.textBox_UI.Clear();
        }
        #endregion
       
    }
}
